<!-- Global site tag (gtag.js) - Google Analytics -->
<script async src="https://www.googletagmanager.com/gtag/js?id=G-Q3VJS7SRTL"></script>
<script>
  window.dataLayer = window.dataLayer || [];
  function gtag(){dataLayer.push(arguments);}
  gtag('js', new Date());

  gtag('config', 'G-Q3VJS7SRTL');
</script>

# Deep Learning _Handbook_

The Deep Learning _Handbook_ is a project in progress to help study the [**Deep Learning book**](https://www.deeplearningbook.org/) by Goodfellow et al.

Goodfellow's masterpiece is a vibrant and precious resource to introduce the booming topic of deep learning. However, many found the accompanying video lectures, slides, and exercises not pedagogic enough for a fresh starter.

I used the **'dlbook'** as the primary reference for the machine learning class that I have taught in Spring 2019/2020 at the computer science department, American University of Beirut.

I would like to share my experience by publishing the slides and some of the assignments on this page. The project may be developed further into a full handbook and guide accompanying the fascinating text of Goodfellow et al.

The target audience comprises:
* undergraduate and graduate students willing to know more about machine and deep learning, be able to read research papers or start a graduation project or a master thesis in the same context,
* developers and practitioners aspiring to a bit more math and philosophy,
* or mathematicians liking to have some hands-on and a bit more coding experience,
* any other bored or sleepless person.

Currently, only part I and part II are covered.

## Slides

### Part I

* [Introduction](slides/01_intro.pdf)

* [Linear Algebra](slides/02_linear_algebra.pdf)

* [Probability](slides/03_prob.pdf)

* [Numerical Analysis](slides/04_numerical.pdf)

* [Machine Learning Basics](slides/05_ml.pdf)


### Part II

* [Multi-Layer Perceptrons](slides/06_mlp.pdf)

* [Regularization](slides/07_regularization.pdf)

* [Optimization](slides/08_optimization.pdf)

* [Convolutional Neural Networks](slides/09_conv.pdf)

* [Recurrent Neural Networks](slides/10_rnn.pdf)


## Exercises

### *Assignment 1 - Linear Algebra*

[Linear Algebra Exercises](exercises/Assignment_1_CMPS_392.pdf)

### *Assignment 2 - Probability*

[Probability Exercises](exercises/Assignment_2_CMPS_392.pdf)

### *Assignment 3 - Numerical Computations*

[Numerical Computations Exercises](exercises/Asst_3_Numerical_Computations.md)

[Notebook](exercises/CMPS_392_Asst_3_Numerical_Computations.ipynb)

### *Assignment 4 - Machine Learning Basics*

[Machine Learning Basics Exercises](exercises/Asst_4_Machine_Learning_Bascis.md)

[Notebook](exercises/CMPS_392_Asst_4_Machine_Learning_Bascis.ipynb)


### *Assignment 5 - Multi-layer Perceptrons*

[Multi-layer perceptrons](exercises/Asst_5_Deep_Feed_Forward_Networks.md)

[Notebook](exercises/CMPS_392_Asst_5_Deep_Feed_Forward_Networks.ipynb)


### *Assignment 6*: Regularization

[Regularization](exercises/Asst_6_Regularization.md)

[Notebook](exercises/CMPS_392_Asst_6_Regularization.ipynb)


### *Assignment 7*: Optimization

Coming soon

### *Assignment 8*: Convolutional Neural Networks (CNN)

Coming soon

### *Assignment 9*: Recurrent Neural Networks (RNN)

Coming soon

## Multi-choice questions: Test your deep learning knowledge

[Test Your Skills](MCQ/bank.pdf)

## Competition

In the context of the Spring 2020 class offering, we have organized an in-class Kaggle competition under the theme: **Android Malware Classification**.

[You can still have a late submission](https://www.kaggle.com/c/aub-cmps-392)

### Winners solutions:

1. [Houdeib & Haidar](https://github.com/mhamadhdeib/Android-Malware-Classification)
2. [Tachanka](https://drive.google.com/open?id=1_WvXiHlUHJe4-ZHdsvJuZagDzVdIwWVw)

## Anonymous Student testimony 
> I think this is one of the best graduate courses I've taken during my Master's degree. The special thing about this course is the parallelism between the theoretical parts and the practical assignments that we were solving. So, it developed both my theoretical and practical skills. Also, making the project as a Kaggle competition stimulated me to work more on it and to compete with other teams in my class.

## Contributions

If you would like to contribute to this guide/handbook, please contact the author at `mn115 at aub.edu.lb`


## Citation
To cite this _handbook_, please use this bibtex entry:
```bibtex
@book{nassar-dlh-2020,
    title={Deep Learning Handbook},
    author={Mohamed Nassar},
    publisher={Zenodo},
    doi={10.5281/zenodo.3881558},
    note={\url{http://mnassar.github.io/deeplearninghandbook}},
    year={2020}
}
```

## Author

[scholar](https://scholar.google.com/citations?user=GrvxLaUAAAAJ)
[researchgate](https://www.researchgate.net/profile/Mohamed_Nassar20)


